#ifndef __TLBPDK_H__
#define __TLBPDK_H__

#include <windows.h>
#include <comcat.h>
#include <ole2.h>
#include <tlbif.h>
#include <olectl.h>

// constants for ITlbContainer::UpdateButtonInfo
#define UPDATE_SIZE					0x01
#define UPDATE_REDRAW				0x02
#define UPDATE_TOOLTIP				0x04

// constants for BUTTONINFO.dwMask
#define BTNINFO_MASK_MODEFLAG		0x01
#define BTNINFO_MASK_ACTIONS		0x02
#define BTNINFO_MASK_SIZE			0x04
#define BTNINFO_MASK_ICON			0x08
#define BTNINFO_MASK_SELECTEDICON	0x10
#define BTNINFO_MASK_DESCRIPTION	0x20
#define BTNINFO_MASK_TEXT			0x40
#define BTNINFO_MASK_ACTUALSIZE		0x80

// constants for BUTTONINFO.dwModeFlags
#define BTN_FLAG_PLANE			0x00000001
#define BTN_FLAG_STOPDRAG		0x00000002
#define BTN_FLAG_COLAPCEONRUN	0x00000004

// constants for BUTTONINFO.dwActions
#define CTMS_PROPERTIES	0x01
#define CTMS_RENAME		0x02
#define CTMS_CHANGEICON	0x04
#define CTMS_HOVERRUN	0x20
//#define CTMS_PASSWORD	0x40

//Button states
#define BTN_S_PUSHED	0x01
#define BTN_S_SELECTED	0x02
#define BTN_S_INMENU	0x04
#define BTN_S_INACTION	0x08

#define ARRAYSIZE(a)    (sizeof(a)/sizeof(a[0]))

//Constans for button state
#define TS_STATE_NORMAL			0x01
#define TS_STATE_OVER			0x02
#define TS_STATE_DOWN			0x03
#define TS_STATE_OPENACTIVE		0x04
#define TS_STATE_OPENINACTIVE	0x05
#define TS_STATE_COUNT		TS_STATE_OPENINACTIVE

//Constants for button type
#define TS_ITEM_BTN					0x0001
#define TS_ITEM_MENUITEM			0x0002
#define TS_ITEM_MENUBTN				0x0004
#define TS_ITEM_MENUSEPARATOR		0x0005
#define TS_ITEM_SEPARATOR			0x0006
#define TS_ITEM_TEXTSEPARATOR		0x0007
#define TS_ITEM_MENUITEMSUBMENU		0x0008
#define TS_ITEM_BTNVERT				0x0009
#define TS_ITEM_MENUBTNVERT			0x000A
#define TS_ITEM_SEPARATORVERT		0x000B
#define TS_ITEM_CAPTION				0x000C
#define TS_ITEM_CHEVRON				0x000D
#define TS_ITEM_CHEVRONVERT			0x000E
#define TS_ITEM_TOPMENUSCROLLER		0x000F
#define TS_ITEM_BOTTOMMENUSCROLLER	0x0010

#define TS_ITEM_SBTOP				0x0011
#define TS_ITEM_SBBOTTOM			0x0012
#define TS_ITEM_SB					0x0013
#define TS_ITEM_SBROLLER			0x0014

#define TS_ITEM_SHOWTEXT			0x0800
#define TS_ITEM_ALWAYSBTN			0x1000
#define TS_ITEM_EXPANDMARK			0x2000
#define TS_ITEM_RUNMARK				0x4000
#define TS_ITEM_ICONONLY			0x8000
#define TS_ITEM_ONTOOLBAR			0x0100

//Constants for ITlbButton::Invoke
#define TBTN_INVOKE_GETTOOLTIPSCOUNT	1  // wParam ignored, (int*) lParam - tooltips count
#define TBTN_INVOKE_GETTOOLTIPRECT		2  // wParam - zero based tooltip index, (RECT*) lParam - rectangle of tooltip
#define TBTN_INVOKE_GETTOOLTIPTEXT		3  // wParam - zero based tooltip index, (char*) lParam - Text of tooltip (1024 max)

//Register
extern BOOL RegisterPlugin(HINSTANCE g_hInst, CLSID clsid, LPTSTR lpszTitle);
extern BOOL UnregisterPlugin(CLSID clsid);
extern CATID CATID_TLBBUTTONS;

#endif