// CpuUsage.h: interface for the CCpuUsage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CPUUSAGE_H__CC7E32A8_FE42_4F7B_B176_8E682C0AD574__INCLUDED_)
#define AFX_CPUUSAGE_H__CC7E32A8_FE42_4F7B_B176_8E682C0AD574__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Need for Windows NT/2000
// start defines
#define SYS_BASIC_INFO       0
#define SYS_PERFORMANCE_INFO 2
#define SYS_TIME_INFO        3

#define Li2Double(x) ((double)((x).HighPart) * 4.294967296E9 + (double)((x).LowPart))

typedef struct
{
    DWORD   dwUnknown1;
    ULONG   uKeMaximumIncrement;
    ULONG   uPageSize;
    ULONG   uMmNumberOfPhysicalPages;
    ULONG   uMmLowestPhysicalPage;
    ULONG   uMmHighestPhysicalPage;
    ULONG   uAllocationGranularity;
    PVOID   pLowestUserAddress;
    PVOID   pMmHighestUserAddress;
    ULONG   uKeActiveProcessors;
    BYTE    bKeNumberProcessors;
    BYTE    bUnknown2;
    WORD    wUnknown3;
} SYSTEM_BASIC_INFORMATION;

typedef struct
{
    LARGE_INTEGER   liIdleTime;
    DWORD           dwSpare[76];
} SYSTEM_PERFORMANCE_INFORMATION;

typedef LONG (WINAPI *PROCNTQSI)(UINT,PVOID,ULONG,PULONG);

typedef struct
{
    LARGE_INTEGER liKeBootTime;
    LARGE_INTEGER liKeSystemTime;
    LARGE_INTEGER liExpTimeZoneBias;
    ULONG         uCurrentTimeZoneId;
    DWORD         dwReserved;
} SYSTEM_TIME_INFORMATION;


class CCpuUsage  
{
	//WinNT values
    LARGE_INTEGER liOldIdleTime;
    LARGE_INTEGER liOldSystemTime;
	//Win32 values
	HKEY hKey;
	DWORD dwCpuUsage;

	BOOL m_isWinNT;
public:
	DWORD GetValue();
	CCpuUsage();
	virtual ~CCpuUsage();

private:
	BOOL isWinNT();
};

#endif // !defined(AFX_CPUUSAGE_H__CC7E32A8_FE42_4F7B_B176_8E682C0AD574__INCLUDED_)
