// PropsDlg.cpp: implementation of the CPropsDlg class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PropsDlg.h"
#include "resource.h"
#include <Commdlg.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPropsDlg::CPropsDlg() : CTrueDialog(IDD_PROPS)
{

}

CPropsDlg::~CPropsDlg()
{

}

void CPropsDlg::OnInitDialog()
{
	SendDlgItemMessage(m_hWnd, IDC_PHYS, BM_SETCHECK, m_data[0].show, 0);
	SendDlgItemMessage(m_hWnd, IDC_VIRT, BM_SETCHECK, m_data[1].show, 0);
	SendDlgItemMessage(m_hWnd, IDC_TOTAL, BM_SETCHECK, m_data[2].show, 0);
	SendDlgItemMessage(m_hWnd, IDC_CPU, BM_SETCHECK, m_showCPU, 0);
}

BOOL CPropsDlg::OnEndDialog()
{
	m_data[0].show = SendDlgItemMessage(m_hWnd, IDC_PHYS, BM_GETCHECK, 0, 0);
	m_data[1].show = SendDlgItemMessage(m_hWnd, IDC_VIRT, BM_GETCHECK, 0, 0);
	m_data[2].show = SendDlgItemMessage(m_hWnd, IDC_TOTAL, BM_GETCHECK, 0, 0);
	m_showCPU = SendDlgItemMessage(m_hWnd, IDC_CPU, BM_GETCHECK, 0, 0);
	return TRUE;
}


LRESULT CPropsDlg::OnDrawItem(UINT ctlID, LPDRAWITEMSTRUCT drawItem)
{
	int idx = -1;
	switch(ctlID)
	{
	case IDC_COLORPHYS:
		idx = 0;
		break;
	case IDC_COLORVIRT:
		idx = 1;
		break;
	case IDC_COLORTOTAL:
		idx = 2;
		break;
	}
	if(idx >= 0)
	{
		HBRUSH hBrush = CreateSolidBrush(m_data[idx].color);
		FillRect(drawItem->hDC, &drawItem->rcItem, hBrush);
		if(drawItem->itemState & ODS_SELECTED)
		{
			DrawEdge(drawItem->hDC, &drawItem->rcItem, BDR_SUNKENINNER, BF_RECT);
		} else
		{
			DrawEdge(drawItem->hDC, &drawItem->rcItem, BDR_RAISEDINNER, BF_RECT);
		}
	}
	return TRUE;
}

void CPropsDlg::OnCommand(DWORD itemID)
{
	int idx = -1;
	switch(itemID)
	{
	case IDC_COLORPHYS:
		idx = 0;
		break;
	case IDC_COLORVIRT:
		idx = 1;
		break;
	case IDC_COLORTOTAL:
		idx = 2;
		break;
	}
	if(idx >= 0)
	{
		static COLORREF colors[16] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

		CHOOSECOLOR cc;
		ZeroMemory(&cc, sizeof(cc));
		cc.lStructSize = sizeof(cc);
		cc.Flags = CC_RGBINIT | CC_ANYCOLOR | CC_FULLOPEN;
		cc.hwndOwner = m_hWnd;
		cc.rgbResult = m_data[idx].color;
		cc.lpCustColors = colors;
		if(ChooseColor(&cc))
		{
			m_data[idx].color = cc.rgbResult;
			InvalidateRect(m_hWnd, NULL, FALSE);
		}
	}
}
