// ClockButton.h: interface for the CClockButton class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CLOCKBUTTON_H__1C003A93_2CA6_4FEA_8EBB_7EFC2AC9CAE2__INCLUDED_)
#define AFX_CLOCKBUTTON_H__1C003A93_2CA6_4FEA_8EBB_7EFC2AC9CAE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CClockButton : public ITlbButton  
{
private:
	void StartTimer();
	void TimerThread();
	void LoadDigits();
	char m_Name[MAX_PATH];
	DWORD m_state;
	DWORD m_ID;
	RECT  m_rc;
	ITlbContainer* m_container;

	BOOL m_showSeconds;
	BOOL m_blinkDots;

	DWORD m_version;
	HBITMAP m_bmpDigits;
	int m_digWidth;
	int m_digHeight;
	BOOL m_digLoaded;

	HBITMAP m_bmpDots;
	int m_dotWidth;
	int m_dotHeight;

	HANDLE hTimerThread;
	HANDLE hStop;
	int tik;

	static DWORD WINAPI TimerTrdProc(LPVOID lpParam);
protected:
	DWORD m_ObjRefCount;
public:
	CClockButton();
	virtual ~CClockButton();

	//IUnknown methods
	STDMETHODIMP QueryInterface(REFIID, LPVOID*);
	STDMETHODIMP_(DWORD) AddRef();
	STDMETHODIMP_(DWORD) Release();

	//ITlbButton methods
    STDMETHODIMP Load(IStream *data);
    STDMETHODIMP Save(IStream *data);
    STDMETHODIMP SetRect(RECT *rcItem);
    STDMETHODIMP SetContainer(ITlbContainer *cont);
    STDMETHODIMP SetID(int btnID);
    STDMETHODIMP Draw(HANDLE hDC, RECT *rcItem);
    STDMETHODIMP OnMouseOver(long keys, int x, int y);
    STDMETHODIMP OnMouseLeave(long keys);
    STDMETHODIMP OnMouseEnter(long keys, int x, int y);
	STDMETHODIMP Create(IStream* data);
	STDMETHODIMP StateChanged(int state, int* needRedraw);
	STDMETHODIMP GetDescription(char* szDescription);
	STDMETHODIMP OnLButtonDown(long key, int x, int y);
	STDMETHODIMP OnLButtonUp(long key, int x, int y);
	STDMETHODIMP Run();
	STDMETHODIMP DoAction(int action);
	STDMETHODIMP SetName(LPCSTR szName);
	STDMETHODIMP_(int) QueryContextMenu(HMENU hMenu, int index, int cmdFirst, int cmdLast);
	STDMETHODIMP InvokeCommand(int ID);
	STDMETHODIMP SetLCID(DWORD dwLCID, HMODULE hResModule);
	STDMETHODIMP GetIconLocation(LPSTR szLocation);
	STDMETHODIMP SetIconLocation(LPCSTR szLocation);
	STDMETHODIMP GetButtonInfo(BUTTONINFO* btninfo);
	STDMETHODIMP Invoke(DWORD id, WPARAM wParam, LPARAM lParam);
};

#endif // !defined(AFX_CLOCKBUTTON_H__1C003A93_2CA6_4FEA_8EBB_7EFC2AC9CAE2__INCLUDED_)
