#include "stdafx.h"
#include "utils.h"

void DrawTransBitmap(HDC dc, HBITMAP bmp, int x, int y, int width, int height, COLORREF MaskColor)
{
	//WriteLog("DrawTransBitmap");
	HDC hdcMem = CreateCompatibleDC(dc);
	HDC hdcMem2 = CreateCompatibleDC(dc);
	if(!hdcMem || !hdcMem2) return;
	HBITMAP hbmTransMask = CreateBitmap(width, height, 1, 1, NULL);
	if(!hbmTransMask)
	{
		DeleteDC(hdcMem);
		DeleteDC(hdcMem2);
		return;
	}

	HBITMAP oldBmp = (HBITMAP) SelectObject(hdcMem, bmp);
    HBITMAP oldBmp2 = (HBITMAP) SelectObject(hdcMem2, hbmTransMask);
	
	SetBkColor(hdcMem, MaskColor);
	BitBlt(hdcMem2, 0, 0, width, height, hdcMem, 0, 0, SRCCOPY);

	SetBkColor(dc, RGB(255, 255, 255));
	SetTextColor(dc, RGB(0, 0, 0));
	
	BitBlt(dc, x, y, width, height, hdcMem, 0, 0, SRCINVERT);
	BitBlt(dc, x, y, width, height, hdcMem2, 0, 0, SRCAND);
	BitBlt(dc, x, y, width, height, hdcMem, 0, 0, SRCINVERT);

	SelectObject(hdcMem, oldBmp);
	SelectObject(hdcMem2, oldBmp2);
	DeleteDC(hdcMem);
	DeleteDC(hdcMem2);
	DeleteObject(hbmTransMask);
}

