// Tracker.h: interface for the CTracker class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRACKER_H__7E8E8CDB_F8E1_4B34_B7E4_830964B9F80B__INCLUDED_)
#define AFX_TRACKER_H__7E8E8CDB_F8E1_4B34_B7E4_830964B9F80B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTracker  
{
	Image*  m_Tracker;
	Image*  m_Ball;
	Image*  m_Icons;
	Image*  m_Mute;

	ImageAttributes*  m_TrackerAttr;
	ImageAttributes*  m_BallAttr;
	ImageAttributes*  m_IconsAttr;
	ImageAttributes*  m_MuteAttr;

	int		m_TrackerLeftMargin;
	int		m_TrackerRightMargin;

	SIZE	m_iconSize;
	SIZE	m_muteSize;
	SIZE	m_trackerSize;
	SIZE	m_ballSize;

	int		m_height;

	int		m_isVertical;

	int TrackerWidth(LPRECT rc) { return m_isVertical ? (rc->bottom - rc->top - m_iconSize.cy) : (rc->right - rc->left - m_iconSize.cx); }
public:
	int GetBallWidth() { return m_ballSize.cx; }
	void GetSliderRect(LPRECT rc, int value, int minVal, int maxVal, LPRECT rcSlider);
	void GetTrackerRect(LPRECT rc, LPRECT rcTrk);
	void GetIconRect(LPRECT rc, LPRECT rcIcon);
	int X2Value(int x, int minVal, int maxVal, LPRECT rc);
	int WherePoint(int x, int y, LPRECT rc, int value, int minVal, int maxVal, int& data);
	void Draw(HDC dc, LPRECT rc, int value, int maxVal, int minVal, int mute, int iconIndex, int active);
	CTracker();

	int GetMinWidth() { return  m_trackerSize.cx + max(m_iconSize.cx, m_muteSize.cx); }

	virtual ~CTracker();

	int GetHeight() { return m_height; }

	void LoadSkin(char* path, BOOL isVertical);
};

#endif // !defined(AFX_TRACKER_H__7E8E8CDB_F8E1_4B34_B7E4_830964B9F80B__INCLUDED_)
