// VolumeBtn.h: interface for the CVolumeBtn class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VOLUMEBTN_H__54B0F3BC_DEE5_49DF_A840_1575B11422CB__INCLUDED_)
#define AFX_VOLUMEBTN_H__54B0F3BC_DEE5_49DF_A840_1575B11422CB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "tracker.h"
#include "mixer.h"

struct VOLUME_CTL
{
	CMixer* mix;
	POINT pos;
};

class CVolumeBtn : public ITlbButton  
{
private:
	void WindowTrd();
	static DWORD WINAPI WindowTrdProc(LPVOID lpParam);
	void LoadFromArray(DWORD* data, int count);
	void Clear();
	void RecalcLayout();
	CTracker* m_trk;

	DWORD* data;
	VOLUME_CTL* m_items;
	int m_count;

	HMODULE m_hRes;

	int offcetDown;
	int downIDX;
	BOOL isDown;
	int maxHeight;

	void OnChangedLine(HMIXER hMix, DWORD ctlID);
	HWND hWndVC;
	static LRESULT CALLBACK VCWndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam);

	char m_Name[MAX_PATH];
	DWORD m_state;
	DWORD m_ID;
	RECT  m_rc;
	ITlbContainer* m_container;

	char m_skin[MAX_PATH];

	DWORD m_version;

	BOOL m_stop;
	HANDLE m_WndTrd;

	int m_activeControl;
	BOOL m_isVertical;
	BOOL m_showType;

	GdiplusStartupInput gdiplusStartupInput;
	ULONG_PTR           gdiplusToken;
protected:
	DWORD m_ObjRefCount;
public:

	//IUnknown methods
	STDMETHODIMP QueryInterface(REFIID, LPVOID*);
	STDMETHODIMP_(DWORD) AddRef();
	STDMETHODIMP_(DWORD) Release();

	//ITlbButton methods
    STDMETHODIMP Load(IStream *data);
    STDMETHODIMP Save(IStream *data);
    STDMETHODIMP SetRect(RECT *rcItem);
    STDMETHODIMP SetContainer(ITlbContainer *cont);
    STDMETHODIMP SetID(int btnID);
    STDMETHODIMP Draw(HANDLE hDC, RECT *rcItem);
    STDMETHODIMP OnMouseOver(long keys, int x, int y);
    STDMETHODIMP OnMouseLeave(long keys);
    STDMETHODIMP OnMouseEnter(long keys, int x, int y);
	STDMETHODIMP Create(IStream* data);
	STDMETHODIMP StateChanged(int state, int* needRedraw);
	STDMETHODIMP OnLButtonDown(long key, int x, int y);
	STDMETHODIMP OnLButtonUp(long key, int x, int y);
	STDMETHODIMP Run();
	STDMETHODIMP DoAction(int action);
	STDMETHODIMP SetName(LPCSTR szName);
	STDMETHODIMP_(int) QueryContextMenu(HMENU hMenu, int index, int cmdFirst, int cmdLast);
	STDMETHODIMP InvokeCommand(int ID);
	STDMETHODIMP SetLCID(DWORD dwLCID, HMODULE hResModule);
	STDMETHODIMP GetIconLocation(LPSTR szLocation);
	STDMETHODIMP SetIconLocation(LPCSTR szLocation);
	STDMETHODIMP GetButtonInfo(BUTTONINFO* btninfo);
	STDMETHODIMP Invoke(DWORD id, WPARAM wParam, LPARAM lParam);
public:
	void AddMixer(DWORD dwComponentType);
	CVolumeBtn();
	virtual ~CVolumeBtn();

private:
	void GetControlRect(int idx, LPRECT rc, LPRECT rcControl);
};

#endif // !defined(AFX_VOLUMEBTN_H__54B0F3BC_DEE5_49DF_A840_1575B11422CB__INCLUDED_)
