#ifndef __GLOBALS_H__
#define __GLOBALS_H__

#include <windows.h>
#include <tlbpdk.h>
#include "resource.h"
#include <gdiplus.h>
using namespace Gdiplus;

extern HINSTANCE   g_hResInst;
extern HINSTANCE   g_hInst;
extern UINT        g_DllRefCount;

extern void StretchBltTransparent(
		HDC hdcDest,      // handle to destination DC
		int nXOriginDest, // x-coord of destination upper-left corner
		int nYOriginDest, // y-coord of destination upper-left corner
		int nWidthDest,   // width of destination rectangle
		int nHeightDest,  // height of destination rectangle
		HDC hdcSrc,       // handle to source DC
		int nXOriginSrc,  // x-coord of source upper-left corner
		int nYOriginSrc,  // y-coord of source upper-left corner
		int nWidthSrc,    // width of source rectangle
		int nHeightSrc,   // height of source rectangle
		COLORREF MaskColor);       // raster operation code

extern void BitBltTransparent(
		HDC hdcDest, // handle to destination DC
		int nXDest,  // x-coord of destination upper-left corner
		int nYDest,  // y-coord of destination upper-left corner
		int nWidth,  // width of destination rectangle
		int nHeight, // height of destination rectangle
		HDC hdcSrc,  // handle to source DC
		int nXSrc,   // x-coordinate of source upper-left corner
		int nYSrc,   // y-coordinate of source upper-left corner
		COLORREF MaskColor);

extern void GetFullSkinPath(LPSTR skinPath, LPSTR fullSkinPath);
extern void GetRelSkinPath(LPSTR fullSkinPath, LPSTR skinPath);


struct VERSION 
{
	DWORD versionMS;
	DWORD versionLS;
};

inline bool operator == (VERSION& v1, VERSION& v2)
{
	if(v1.versionMS == v2.versionMS && v1.versionLS == v2.versionLS)
	{
		return true;
	}
	return false;
}

inline bool operator >= (VERSION& v1, VERSION& v2)
{
	if(v1 == v2) return true;
	if(v1.versionMS > v2.versionMS)
	{
		return true;
	}
	if(v1.versionMS == v2.versionMS && v1.versionMS > v2.versionMS)
	{
		return true;
	}
	return false;
}

inline bool operator <= (VERSION& v1, VERSION& v2)
{
	if(v2 >= v1)
	{
		return true;
	}
	return false;
}

inline bool operator > (VERSION& v1, VERSION& v2)
{
	if(v1.versionMS > v2.versionMS)
	{
		return true;
	}
	if(v1.versionMS == v2.versionMS && v1.versionMS > v2.versionMS)
	{
		return true;
	}
	return false;
}

inline bool operator < (VERSION& v1, VERSION& v2)
{
	if(v2 > v1)
	{
		return true;
	}
	return false;
}

extern void Version2Str(DWORD versionMS, DWORD versionLS, char* str);
extern void GetFileVersion(LPCTSTR fileName, DWORD& versionMS, DWORD& versionLS);

#endif