#include "globals.h"

void StretchBltTransparent(
		HDC hdcDest,      // handle to destination DC
		int nXOriginDest, // x-coord of destination upper-left corner
		int nYOriginDest, // y-coord of destination upper-left corner
		int nWidthDest,   // width of destination rectangle
		int nHeightDest,  // height of destination rectangle
		HDC hdcSrc,       // handle to source DC
		int nXOriginSrc,  // x-coord of source upper-left corner
		int nYOriginSrc,  // y-coord of source upper-left corner
		int nWidthSrc,    // width of source rectangle
		int nHeightSrc,   // height of source rectangle
		COLORREF MaskColor)       // raster operation code
{
	HDC hdcMem2 = CreateCompatibleDC(hdcDest);
	if(!hdcMem2)
	{
		return;
	}
	HBITMAP hbmTransMask = CreateBitmap(nWidthSrc, nHeightSrc, 1, 1, NULL);
	if(!hbmTransMask)
	{
		DeleteDC(hdcMem2);
		return;
	}

    HBITMAP oldBmp2 = (HBITMAP) SelectObject(hdcMem2, hbmTransMask);
	
	COLORREF oldColor = SetBkColor(hdcSrc, MaskColor);
	BitBlt(hdcMem2, 0, 0, nWidthSrc, nHeightSrc, hdcSrc, nXOriginSrc, nYOriginSrc, SRCCOPY);

	SetBkColor(hdcDest, RGB(255, 255, 255));
	SetTextColor(hdcDest, RGB(0, 0, 0));
	
	StretchBlt(hdcDest, nXOriginDest, nYOriginDest, nWidthDest, nHeightDest, hdcSrc, nXOriginSrc, nYOriginSrc, nWidthSrc, nHeightSrc, SRCINVERT);
	StretchBlt(hdcDest, nXOriginDest, nYOriginDest, nWidthDest, nHeightDest, hdcMem2, 0, 0, nWidthSrc, nHeightSrc, SRCAND);
	StretchBlt(hdcDest, nXOriginDest, nYOriginDest, nWidthDest, nHeightDest, hdcSrc, nXOriginSrc, nYOriginSrc, nWidthSrc, nHeightSrc, SRCINVERT);

	SetBkColor(hdcSrc, oldColor);
	SelectObject(hdcMem2, oldBmp2);
	DeleteDC(hdcMem2);
	DeleteObject(hbmTransMask);
}


void BitBltTransparent(
		HDC hdcDest, // handle to destination DC
		int nXDest,  // x-coord of destination upper-left corner
		int nYDest,  // y-coord of destination upper-left corner
		int nWidth,  // width of destination rectangle
		int nHeight, // height of destination rectangle
		HDC hdcSrc,  // handle to source DC
		int nXSrc,   // x-coordinate of source upper-left corner
		int nYSrc,   // y-coordinate of source upper-left corner
		COLORREF MaskColor)
{
	HDC hdcMem2 = CreateCompatibleDC(hdcDest);
	if(!hdcMem2)
	{
		return;
	}
	HBITMAP hbmTransMask = CreateBitmap(nWidth, nHeight, 1, 1, NULL);
	if(!hbmTransMask)
	{
		DeleteDC(hdcMem2);
		return;
	}

    HBITMAP oldBmp2 = (HBITMAP) SelectObject(hdcMem2, hbmTransMask);
	
	COLORREF oldColor = SetBkColor(hdcSrc, MaskColor);
	BitBlt(hdcMem2, 0, 0, nWidth, nHeight, hdcSrc, nXSrc, nYSrc, SRCCOPY);

	SetBkColor(hdcDest, RGB(255, 255, 255));
	SetTextColor(hdcDest, RGB(0, 0, 0));
	
	BitBlt(hdcDest, nXDest, nYDest, nWidth, nHeight, hdcSrc, nXSrc, nYSrc, SRCINVERT);
	BitBlt(hdcDest, nXDest, nYDest, nWidth, nHeight, hdcMem2, 0, 0, SRCAND);
	BitBlt(hdcDest, nXDest, nYDest, nWidth, nHeight, hdcSrc, nXSrc, nYSrc, SRCINVERT);

	SetBkColor(hdcSrc, oldColor);
	SelectObject(hdcMem2, oldBmp2);
	DeleteDC(hdcMem2);
	DeleteObject(hbmTransMask);
}
